Debian Bug report logs - #661537
Support for staged/bootstrap builds to break cyclic build-dependencies

version graph

Package: apt; Maintainer for apt is APT Development Team <deity@lists.debian.org>; Source for apt is src:apt.

Reported by: Wookey <wookey@debian.org>

Date: Mon, 27 Feb 2012 21:39:01 UTC

Severity: wishlist

Tags: patch

Found in version apt/0.8.15.9

Fixed in version apt/0.9.16

Done: Michael Vogt <mvo@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, APT Development Team <deity@lists.debian.org>:
Bug#661537; Package apt. (Mon, 27 Feb 2012 21:39:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Wookey <wookey@debian.org>:
New Bug report received and forwarded. Copy sent to APT Development Team <deity@lists.debian.org>. (Mon, 27 Feb 2012 21:39:05 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Wookey <wookey@debian.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: Support for staged/bootstrap builds to break cyclic build-dependencies
Date: Mon, 27 Feb 2012 19:00:58 +0000
[Message part 1 (text/plain, inline)]
Package: apt
Version: 0.8.15.9
Severity: wishlist
Tags: patch

Cyclic build-dependencies are a big problem in Debian, which make new
ports very difficult, or rebuilds for other reasons such as hardware optimisations.

The subject is covered in some detail here: http://wiki.debian.org/DebianBootstrap
and was covered at Debconf in Baja Luka.

This little patch allows Build-Depends-Stage1 to be added to package
control files, which is the proposed solution to this issue.

If we can get it into Wheezy then it will be easy to do work on this
problem without needed a patched apt. 

-- Package-specific info:

-- (no /etc/apt/preferences present) --


-- (/etc/apt/sources.list present, but not submitted) --


-- System Information:
Debian Release: wheezy/sid
  APT prefers testing
  APT policy: (990, 'testing')
Architecture: amd64 (x86_64)

Kernel: Linux 3.1.0-1-amd64 (SMP w/2 CPU cores)
Locale: LANG=en_GB.UTF-8, LC_CTYPE=en_GB.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/bash

Versions of packages apt depends on:
ii  debian-archive-keyring  2010.08.28
ii  gnupg                   1.4.11-3
ii  libc6                   2.13-26
ii  libgcc1                 1:4.6.2-12
ii  libstdc++6              4.6.2-12
ii  zlib1g                  1:1.2.6.dfsg-1

apt recommends no packages.

Versions of packages apt suggests:
ii  apt-doc     <none>
ii  aptitude    0.6.5-1
ii  bzip2       1.0.6-1
ii  dpkg-dev    1.16.1.2
ii  lzma        9.22-2
ii  python-apt  0.8.3+nmu1
ii  synaptic    0.75.4

-- no debconf information
[dpkg-1.16.0.3-stage1.patch (text/x-diff, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, APT Development Team <deity@lists.debian.org>:
Bug#661537; Package apt. (Mon, 27 Feb 2012 22:06:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to David Kalnischkies <kalnischkies+debian@gmail.com>:
Extra info received and forwarded to list. Copy sent to APT Development Team <deity@lists.debian.org>. (Mon, 27 Feb 2012 22:06:07 GMT) Full text and rfc822 format available.

Message #10 received at 661537@bugs.debian.org (full text, mbox):

From: David Kalnischkies <kalnischkies+debian@gmail.com>
To: Wookey <wookey@debian.org>, 661537@bugs.debian.org
Subject: Re: Bug#661537: Support for staged/bootstrap builds to break cyclic build-dependencies
Date: Mon, 27 Feb 2012 23:04:06 +0100
On Mon, Feb 27, 2012 at 20:00, Wookey <wookey@debian.org> wrote:
> This little patch allows Build-Depends-Stage1 to be added to package
> control files, which is the proposed solution to this issue.

Is the discussion on that feature completed?
I vaguely recall "complains" about the naming and such stuff.
(Just want to avoid that this ends in a disaster like multiarch…)


> If we can get it into Wheezy then it will be easy to do work on this
> problem without needed a patched apt.

Attached was a patch for dpkg and the wiki also only mentions one
for dpkg. If there is one for APT and the feature is frozen i am sure
Michael will be fine with pushing it for wheezy.


I am not sure through how apt is supposed to be useful in this context
as it is high in the stack (in terms of bootstrapping), but i need to confess
that i consider bootstrapping "magic" so far, so i am properly wrong.


Best regards

David Kalnischkies




Information forwarded to debian-bugs-dist@lists.debian.org, APT Development Team <deity@lists.debian.org>:
Bug#661537; Package apt. (Fri, 11 May 2012 16:51:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Wookey <wookey@wookware.org>:
Extra info received and forwarded to list. Copy sent to APT Development Team <deity@lists.debian.org>. (Fri, 11 May 2012 16:51:02 GMT) Full text and rfc822 format available.

Message #15 received at 661537@bugs.debian.org (full text, mbox):

From: Wookey <wookey@wookware.org>
To: 661537@bugs.debian.org
Subject: Re: Support for staged/bootstrap builds to break cyclic build-dependencies
Date: Fri, 11 May 2012 17:50:17 +0100
[Message part 1 (text/plain, inline)]
David Kalnischkies <kalnischkies+debian@gmail.com> wrote:
> On Mon, Feb 27, 2012 at 20:00, Wookey <wookey@debian.org> wrote:
> > This little patch allows Build-Depends-Stage1 to be added to package
> > control files, which is the proposed solution to this issue.

> Is the discussion on that feature completed?
> I vaguely recall "complains" about the naming and such stuff.
> (Just want to avoid that this ends in a disaster like multiarch…)

I beleive so, but I've been planning to confirm on -devel for ages.
It's really urgent now, so mail is in progress.

> Attached was a patch for dpkg and the wiki also only mentions one
> for dpkg. If there is one for APT and the feature is frozen i am sure
> Michael will be fine with pushing it for wheezy.

Sorry - cock up. Attached is the patch I meant to send, now updated
to include -stage2 fields too and for current apt.

I don't really understand what the 'Type' thing is about - is it just
a field index number or something else?

> I am not sure through how apt is supposed to be useful in this context
> as it is high in the stack (in terms of bootstrapping), but i need to confess
> that i consider bootstrapping "magic" so far, so i am properly wrong.

The existing patch just stops apt complaining about these new fields
it's never heard of.

I have actually realised that more work is needed if we want apt-get
build-dep to do the right thing when bootstrapping. A clue as to where
in the code to look to make that change would be useful. I'm sending
mail to the deity list about that.

Wookey
[apt-0.9.2-stage2.patch (text/x-diff, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, APT Development Team <deity@lists.debian.org>:
Bug#661537; Package apt. (Sun, 16 Feb 2014 12:33:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Johannes Schauer <j.schauer@email.de>:
Extra info received and forwarded to list. Copy sent to APT Development Team <deity@lists.debian.org>. (Sun, 16 Feb 2014 12:33:04 GMT) Full text and rfc822 format available.

Message #20 received at 661537@bugs.debian.org (full text, mbox):

From: Johannes Schauer <j.schauer@email.de>
To: 661537@bugs.debian.org
Subject: implementation of the BuildProfileSpec for apt
Date: Sun, 16 Feb 2014 13:31:45 +0100
[Message part 1 (text/plain, inline)]
Hi,

I thought it would be okay to cross-post my patches from the deity mailing list
[1] into this bugreport to keep this bugreport up to date and so that the patch
does not get lost.

As pointed out on the list, please dont forget to make apt's binary dependency
on dpkg a versiond one on dpkg-dev (>= 1.17.2) because "apt-get source --build
-P stage1 hello" now calls dpkg-buildpackage with the new -P argument.

cheers, josch

[1] https://lists.debian.org/deity/2014/02/msg00057.html
[0001-support-new-command-line-argument-type-Vector-given-.patch (text/x-diff, attachment)]
[0002-Support-for-build-profiles-through-APT-Build-Profile.patch (text/x-diff, attachment)]

Reply sent to Michael Vogt <mvo@debian.org>:
You have taken responsibility. (Fri, 14 Mar 2014 09:54:09 GMT) Full text and rfc822 format available.

Notification sent to Wookey <wookey@debian.org>:
Bug acknowledged by developer. (Fri, 14 Mar 2014 09:54:09 GMT) Full text and rfc822 format available.

Message #25 received at 661537-close@bugs.debian.org (full text, mbox):

From: Michael Vogt <mvo@debian.org>
To: 661537-close@bugs.debian.org
Subject: Bug#661537: fixed in apt 0.9.16
Date: Fri, 14 Mar 2014 09:50:02 +0000
Source: apt
Source-Version: 0.9.16

We believe that the bug you reported is fixed in the latest version of
apt, which is due to be installed in the Debian FTP archive.

A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 661537@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Michael Vogt <mvo@debian.org> (supplier of updated apt package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@ftp-master.debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Fri, 14 Mar 2014 09:45:05 +0100
Source: apt
Binary: apt libapt-pkg4.12 libapt-inst1.5 apt-doc libapt-pkg-dev libapt-pkg-doc apt-utils apt-transport-https
Architecture: source all amd64
Version: 0.9.16
Distribution: unstable
Urgency: medium
Maintainer: APT Development Team <deity@lists.debian.org>
Changed-By: Michael Vogt <mvo@debian.org>
Description: 
 apt        - commandline package manager
 apt-doc    - documentation for APT
 apt-transport-https - https download transport for APT
 apt-utils  - package management related utility programs
 libapt-inst1.5 - deb package format runtime library
 libapt-pkg-dev - development files for APT's libapt-pkg and libapt-inst
 libapt-pkg-doc - documentation for APT development
 libapt-pkg4.12 - package management runtime library
Closes: 661537 740673 740843 741056
Changes: 
 apt (0.9.16) unstable; urgency=medium
 .
   [ Michael Vogt ]
   * add hashsum support in apt-helper download-file and
     add more tests
 .
   [ Trần Ngọc Quân ]
   * l10n: vi.po (624t): Update Vietnamese translation
 .
   [ David Kalnischkies ]
   * propagate a negative score point along breaks/conflicts
   * check version before adding scores in resolver
   * autogenerate makefile for vendor system
   * add default and override handling for Cnf::FindVector
   * support DEB_BUILD_PROFILES and -P for build profiles
   * do not configure already unpacked packages needlessly (Closes: 740843)
   * if mountpoint has a ".disk" directory it is mounted
   * no error for non-existing mountpoints in MountCdrom
   * apt-cdrom ident shouldn't be interactive (Closes: 740673)
   * support very long mtab entries in mountpoint discovery
   * msgstr with elipses need three dots
   * cmdline parsing: apt-config is not apt-cdrom
   * use a configurable list of versioned kernel packages
   * support kfreebsd and hurd in the kernel hook
   * add ".*-{kernel,modules}-$KERVER" matcher for hook
   * ensure that a dot is a dot in the hook
   * use liblzma-dev to provide xz/lzma support
   * use the pretty fullname of a pkg as download desciption
 .
   [ Johannes Schauer ]
   * implement BuildProfileSpec support as dpkg has in 1.17.2 (Closes: 661537)
 .
   [ Wojciech Górski ]
   * fix polish --install-suggests text in apt-get manpage (Closes: 741056)
Checksums-Sha1: 
 131078a4e5bff780a8d5bfd5aac196a8a8177025 1638 apt_0.9.16.dsc
 88f89e8cec134b951371013ceb706ce1373771bd 1734784 apt_0.9.16.tar.xz
 c4e4720044a0434ccf803d7cb0cd9c261a0906bc 270724 apt-doc_0.9.16_all.deb
 d78931fa7027bc61c6fa96f1fc1693bcb117323e 766790 libapt-pkg-doc_0.9.16_all.deb
 d494798e128855de9735b5c5a1e415b616ffa880 743384 libapt-pkg4.12_0.9.16_amd64.deb
 dc1504c2f88e6d66439189d669603e2017fb96db 162490 libapt-inst1.5_0.9.16_amd64.deb
 81eedba06f88dcd121ab65354c7f552f266ace98 1062452 apt_0.9.16_amd64.deb
 64e38f60c3d90a35e53c67047f05c87de6190b33 186468 libapt-pkg-dev_0.9.16_amd64.deb
 2dfedef00f9920e14c78cbdd327841ee24c50069 349466 apt-utils_0.9.16_amd64.deb
 97530050b15f2d8f9b0f0cec4264d81f0b51ffc5 129148 apt-transport-https_0.9.16_amd64.deb
Checksums-Sha256: 
 c5f080a8f80ed969a5527a326b638f96ba4b26e4792710359a25d2e4d34916ac 1638 apt_0.9.16.dsc
 d6578c1510dcad6d63630e385e998384512da3c64fb09f8a381364e11f01c513 1734784 apt_0.9.16.tar.xz
 b4a348de3caa1a95ad11a8ce8496d0a4b0e496c020de764a627820708d7100e3 270724 apt-doc_0.9.16_all.deb
 02bbc61e603e3d299d9f42790c095fe58d586775a821273e0f5487b390e441df 766790 libapt-pkg-doc_0.9.16_all.deb
 184a24d86a7b2378ec3b16fb35a6b1ff8787697ced13214c28347ce42c94be5e 743384 libapt-pkg4.12_0.9.16_amd64.deb
 33ec9ac43621d9b3beba31f377641e60175f0b4e07f6c6928730201e63141140 162490 libapt-inst1.5_0.9.16_amd64.deb
 4751b238e7b06605fa159862b1595df856944f99ab6ce1a70f9642675e354d37 1062452 apt_0.9.16_amd64.deb
 a7ca0ea54f6e8a1f8edc13766bc038dc1f8be9707c41e826456f82443f77a048 186468 libapt-pkg-dev_0.9.16_amd64.deb
 c60caeb5519111acc151adb4c27d9ee281a279186f583ddfd25835b04d380ecb 349466 apt-utils_0.9.16_amd64.deb
 5c98075ba411007c11b6824ed0e5e903e89fa9a18bf2447a1ab0e14257d4c313 129148 apt-transport-https_0.9.16_amd64.deb
Files: 
 9d0f3f359fd7cbe973526c88e39ced44 1638 admin important apt_0.9.16.dsc
 9ebe9a76dac4fb453c030ee584756f6d 1734784 admin important apt_0.9.16.tar.xz
 bba391e04ef93fe3d7298981a0d9eb3d 270724 doc optional apt-doc_0.9.16_all.deb
 082f4caf75dc54e691a64ba5df570bce 766790 doc optional libapt-pkg-doc_0.9.16_all.deb
 3c413ad5c5fdabe0fb76035d76afac5f 743384 libs important libapt-pkg4.12_0.9.16_amd64.deb
 0aadeff033c0f147671938cf10ee6d0b 162490 libs important libapt-inst1.5_0.9.16_amd64.deb
 9bb168f072739ba11938c5e499d3f956 1062452 admin important apt_0.9.16_amd64.deb
 fde072f19e881b614ece35b4d1791cf5 186468 libdevel optional libapt-pkg-dev_0.9.16_amd64.deb
 098f3d2a85e9ec23f71670b45a69e8f8 349466 admin important apt-utils_0.9.16_amd64.deb
 ab1fcac9195fa6b2a6c0a491b52b9b84 129148 admin optional apt-transport-https_0.9.16_amd64.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1

iEYEARECAAYFAlMixlcACgkQliSD4VZixzR8vQCfYggVmYiKG6ARbCwY8mChZTQU
S6UAn2gzGj23sBbN2MeKTtSREilvYZAx
=aFHK
-----END PGP SIGNATURE-----




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Sat, 12 Apr 2014 07:27:37 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Wed Apr 16 16:46:00 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.